part of gauges;

/// Represents the annotation renderer
///
// ignore: must_be_immutable
class _AnnotationRenderer extends StatefulWidget {
  ///Creates the annotation renderer
  ///
  // ignore: prefer_const_constructors_in_immutables
  _AnnotationRenderer({this.key, this.annotation}) : super(key: key);

  /// specifies the annotation
  GaugeAnnotation annotation;

  /// Specifies the key annotation renderer
  GlobalKey key;

  @override
  State<StatefulWidget> createState() {
    return _AnnotationRendererState();
  }
}

/// Represents the annotation renderer state
class _AnnotationRendererState extends State<_AnnotationRenderer> {
  @override
  void initState() {
    super.initState();

    WidgetsBinding.instance
        .addPostFrameCallback((_) => _calculateAnnotationPosition(context));
  }

  /// Calculates the annotation position based on its size
  void _calculateAnnotationPosition(BuildContext _context) {
    final RenderBox renderBox = _context.findRenderObject();
    setState(() {
      widget.annotation._annotationSize = renderBox.size;
      widget.annotation._opacity = 1;
      widget.annotation._left = widget.annotation._annotationPosition.dx -
          (widget.annotation.horizontalAlignment == GaugeAlignment.near
              ? 0
              : widget.annotation.horizontalAlignment == GaugeAlignment.center
                  ? widget.annotation._annotationSize.width / 2
                  : widget.annotation._annotationSize.width);
      widget.annotation._top = widget.annotation._annotationPosition.dy -
          (widget.annotation.verticalAlignment == GaugeAlignment.near
              ? 0
              : widget.annotation.verticalAlignment == GaugeAlignment.center
                  ? widget.annotation._annotationSize.height / 2
                  : widget.annotation._annotationSize.height);
    });
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Positioned(
        left: widget.annotation._left,
        top: widget.annotation._top,
        child: Opacity(
            opacity: widget.annotation._opacity,
            child: widget.annotation.widget));
  }
}
