part of gauges;

/// Represents the painter to render the needle pointer
class _NeedlePointerPainter extends CustomPainter {
  /// Creates the needle pointer painter
  _NeedlePointerPainter(this._gauge, this._axis, this._needlePointer,
      this._isRepaint, this._pointerAnimation, ValueNotifier<num> notifier)
      : super(repaint: notifier);

  /// Specifies the circular gauge
  final SfRadialGauge _gauge;

  /// Specifies the gauge axis
  final RadialAxis _axis;

  /// Specifies the needle pointer
  final NeedlePointer _needlePointer;

  /// Specifies whether to redraw the pointer
  final bool _isRepaint;

  /// Specifies the animation value of needle pointer
  final Animation<double> _pointerAnimation;

  @override
  void paint(Canvas canvas, Size size) {
    double _angle = 0;
    if (_needlePointer.enableAnimation &&
        _needlePointer.animationDuration > 0 &&
        _needlePointer._needsAnimate) {
      _angle = (_axis._sweepAngle * _pointerAnimation.value) + _axis.startAngle;
      _needlePointer._calculateNeedleOffset(_degreeToRadian(_angle));
    } else {
      _angle = _needlePointer._angle;
    }
    final Offset startPosition =
        Offset(_needlePointer._startX, _needlePointer._startY);
    final Offset endPosition =
        Offset(_needlePointer._stopX, _needlePointer._stopY);
    final double _animationValue = (_needlePointer.enableAnimation &&
            _needlePointer.animationDuration > 0 &&
            _needlePointer._needsAnimate)
        ? _pointerAnimation.value
        : null;
    _needlePointer.drawPointer(
        canvas, _animationValue, startPosition, endPosition, _angle);

    if (_needlePointer.enableAnimation &&
        _needlePointer.animationDuration > 0 &&
        _angle ==
            _axis._sweepAngle * _needlePointer._animationEndValue +
                _axis.startAngle) {
      WidgetsBinding.instance.addPostFrameCallback((_) {
        _gauge._radialGaugeState._updateAnimation(_needlePointer);
      });
    }
  }

  @override
  bool shouldRepaint(_NeedlePointerPainter oldDelegate) => _isRepaint;
}
